/* App.c generated by valac 0.52.4, the Vala compiler
 * generated from App.vala, do not modify */

/*
* Copyright 2020 elementary, Inc. (https://elementary.io)
*           2020 Martin Abente Lahaye
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Marius Meisenzahl <mariusmeisenzahl@gmail.com>
*/

#include "applications.h"
#include <flatpak.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

enum  {
	PERMISSIONS_BACKEND_APP_0_PROPERTY,
	PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY,
	PERMISSIONS_BACKEND_APP_ID_PROPERTY,
	PERMISSIONS_BACKEND_APP_NAME_PROPERTY,
	PERMISSIONS_BACKEND_APP_NUM_PROPERTIES
};
static GParamSpec* permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

struct _PermissionsBackendAppPrivate {
	FlatpakInstalledRef* _installed_ref;
	gchar* _id;
	gchar* _name;
};

struct _Block4Data {
	int _ref_count_;
	PermissionsBackendApp* self;
	GPtrArray* permissions;
	GPtrArray* current_permissions;
};

static gint PermissionsBackendApp_private_offset;
static gpointer permissions_backend_app_parent_class = NULL;

#define PERMISSIONS_BACKEND_APP_GROUP "Context"
static gchar* permissions_backend_app_get_overrides_path (PermissionsBackendApp* self);
static gboolean permissions_backend_app_is_permission_overridden (PermissionsBackendApp* self,
                                                           GPtrArray* overrides,
                                                           const gchar* permission);
static GPtrArray* permissions_backend_app_get_permissions_for_keyfile (PermissionsBackendApp* self,
                                                                GKeyFile* key_file);
static void _g_free0_ (gpointer var);
static void permissions_backend_app_set_id (PermissionsBackendApp* self,
                                     const gchar* value);
static void permissions_backend_app_set_name (PermissionsBackendApp* self,
                                       const gchar* value);
static GObject * permissions_backend_app_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _g_object_unref0_ (gpointer var);
static void _permissions_backend_app___lambda30_ (Block4Data* _data4_,
                                           const gchar* key);
static void __permissions_backend_app___lambda30__gh_func (gconstpointer key,
                                                    gconstpointer value,
                                                    gpointer self);
static void _permissions_backend_app_save_overrides_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void permissions_backend_app_finalize (GObject * obj);
static GType permissions_backend_app_get_type_once (void);
static void _vala_permissions_backend_app_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_permissions_backend_app_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
permissions_backend_app_get_instance_private (PermissionsBackendApp* self)
{
	return G_STRUCT_MEMBER_P (self, PermissionsBackendApp_private_offset);
}

PermissionsBackendApp*
permissions_backend_app_construct (GType object_type,
                                   FlatpakInstalledRef* installed_ref)
{
	PermissionsBackendApp * self = NULL;
	g_return_val_if_fail (installed_ref != NULL, NULL);
	self = (PermissionsBackendApp*) g_object_new (object_type, "installed-ref", installed_ref, NULL);
	return self;
}

PermissionsBackendApp*
permissions_backend_app_new (FlatpakInstalledRef* installed_ref)
{
	return permissions_backend_app_construct (PERMISSIONS_BACKEND_TYPE_APP, installed_ref);
}

static gchar*
permissions_backend_app_get_overrides_path (PermissionsBackendApp* self)
{
	gchar* overrides_folder_path = NULL;
	PermissionsBackendFlatpakManager* _tmp0_;
	PermissionsBackendFlatpakManager* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* overrides_folder = NULL;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = permissions_backend_flatpak_manager_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = permissions_backend_flatpak_manager_get_user_installation_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, _tmp3_, "overrides", NULL);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp1_);
	overrides_folder_path = _tmp5_;
	_tmp6_ = overrides_folder_path;
	_tmp7_ = g_file_new_for_path (_tmp6_);
	overrides_folder = _tmp7_;
	_tmp8_ = overrides_folder;
	if (!g_file_query_exists (_tmp8_, NULL)) {
		{
			GFile* _tmp9_;
			_tmp9_ = overrides_folder;
			g_file_make_directory (_tmp9_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp10_ = e;
			_tmp11_ = _tmp10_->message;
			g_critical ("App.vala:133: Couldn't create overrides folder: %s", _tmp11_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (overrides_folder);
			_g_free0 (overrides_folder_path);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp12_ = overrides_folder_path;
	_tmp13_ = self->priv->_id;
	_tmp14_ = g_build_path (G_DIR_SEPARATOR_S, _tmp12_, _tmp13_, NULL);
	result = _tmp14_;
	_g_object_unref0 (overrides_folder);
	_g_free0 (overrides_folder_path);
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

static gboolean
permissions_backend_app_is_permission_overridden (PermissionsBackendApp* self,
                                                  GPtrArray* overrides,
                                                  const gchar* permission)
{
	gchar* _tmp0_ = NULL;
	gchar* negated_permission = NULL;
	gchar* _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (overrides != NULL, FALSE);
	g_return_val_if_fail (permission != NULL, FALSE);
	if (string_contains (permission, "=!")) {
		gchar* _tmp1_;
		_tmp1_ = string_replace (permission, "=!", "=");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = string_replace (permission, "=", "=!");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = g_strdup (_tmp0_);
	negated_permission = _tmp3_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gint _tmp6_;
				gint _tmp7_;
				gchar* o = NULL;
				gconstpointer _tmp8_;
				gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = vala_g_ptr_array_get_length (overrides);
				_tmp7_ = _tmp6_;
				if (!(i < _tmp7_)) {
					break;
				}
				_tmp8_ = g_ptr_array_index (overrides, (guint) i);
				_tmp9_ = g_strdup ((const gchar*) _tmp8_);
				o = _tmp9_;
				_tmp10_ = o;
				_tmp11_ = negated_permission;
				if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
					result = TRUE;
					_g_free0 (o);
					_g_free0 (negated_permission);
					_g_free0 (_tmp0_);
					return result;
				}
				_g_free0 (o);
			}
		}
	}
	result = FALSE;
	_g_free0 (negated_permission);
	_g_free0 (_tmp0_);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
permissions_backend_app_reset_settings_to_standard (PermissionsBackendApp* self)
{
	GFile* file = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				PermissionsBackendPermissionSettings* setting = NULL;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				PermissionsBackendPermissionSettings* _tmp7_;
				PermissionsBackendPermissionSettings* _tmp8_;
				PermissionsBackendPermissionSettings* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->settings;
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				_tmp5_ = self->settings;
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
				_tmp7_ = _g_object_ref0 ((PermissionsBackendPermissionSettings*) _tmp6_);
				setting = _tmp7_;
				_tmp8_ = setting;
				_tmp9_ = setting;
				_tmp10_ = permissions_backend_permission_settings_get_standard (_tmp9_);
				_tmp11_ = _tmp10_;
				permissions_backend_permission_settings_set_enabled (_tmp8_, _tmp11_);
				_g_object_unref0 (setting);
			}
		}
	}
	_tmp12_ = permissions_backend_app_get_overrides_path (self);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_file_new_for_path (_tmp13_);
	_tmp15_ = _tmp14_;
	_g_free0 (_tmp13_);
	file = _tmp15_;
	{
		g_file_delete (file, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp16_ = e;
		_tmp17_ = _tmp16_->message;
		g_warning ("App.vala:169: %s", _tmp17_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (file);
}

void
permissions_backend_app_save_overrides (PermissionsBackendApp* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp0_;
		GKeyFile* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		_tmp0_ = g_key_file_new ();
		key_file = _tmp0_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp1_ = FALSE;
				_tmp1_ = TRUE;
				while (TRUE) {
					GPtrArray* _tmp3_;
					gint _tmp4_;
					gint _tmp5_;
					PermissionsBackendPermissionSettings* setting = NULL;
					GPtrArray* _tmp6_;
					gconstpointer _tmp7_;
					PermissionsBackendPermissionSettings* _tmp8_;
					PermissionsBackendPermissionSettings* _tmp9_;
					gboolean _tmp10_;
					gboolean _tmp11_;
					PermissionsBackendPermissionSettings* _tmp12_;
					gboolean _tmp13_;
					gboolean _tmp14_;
					if (!_tmp1_) {
						gint _tmp2_;
						_tmp2_ = i;
						i = _tmp2_ + 1;
					}
					_tmp1_ = FALSE;
					_tmp3_ = self->settings;
					_tmp4_ = vala_g_ptr_array_get_length (_tmp3_);
					_tmp5_ = _tmp4_;
					if (!(i < _tmp5_)) {
						break;
					}
					_tmp6_ = self->settings;
					_tmp7_ = g_ptr_array_index (_tmp6_, (guint) i);
					_tmp8_ = _g_object_ref0 ((PermissionsBackendPermissionSettings*) _tmp7_);
					setting = _tmp8_;
					_tmp9_ = setting;
					_tmp10_ = permissions_backend_permission_settings_get_enabled (_tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = setting;
					_tmp13_ = permissions_backend_permission_settings_get_standard (_tmp12_);
					_tmp14_ = _tmp13_;
					if (_tmp11_ != _tmp14_) {
						gchar** key_value_pair = NULL;
						PermissionsBackendPermissionSettings* _tmp15_;
						const gchar* _tmp16_;
						const gchar* _tmp17_;
						gchar** _tmp18_;
						gchar** _tmp19_;
						gint key_value_pair_length1;
						gint _key_value_pair_size_;
						gchar* key = NULL;
						gchar** _tmp20_;
						gint _tmp20__length1;
						const gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* value = NULL;
						gchar** _tmp23_;
						gint _tmp23__length1;
						const gchar* _tmp24_;
						gchar* _tmp25_;
						PermissionsBackendPermissionSettings* _tmp26_;
						gboolean _tmp27_;
						gboolean _tmp28_;
						GKeyFile* _tmp31_;
						GKeyFile* _tmp40_;
						const gchar* _tmp41_;
						const gchar* _tmp42_;
						_tmp15_ = setting;
						_tmp16_ = permissions_backend_permission_settings_get_context (_tmp15_);
						_tmp17_ = _tmp16_;
						_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "=", 0);
						key_value_pair = _tmp19_;
						key_value_pair_length1 = _vala_array_length (_tmp18_);
						_key_value_pair_size_ = key_value_pair_length1;
						_tmp20_ = key_value_pair;
						_tmp20__length1 = key_value_pair_length1;
						_tmp21_ = _tmp20_[0];
						_tmp22_ = g_strdup (_tmp21_);
						key = _tmp22_;
						_tmp23_ = key_value_pair;
						_tmp23__length1 = key_value_pair_length1;
						_tmp24_ = _tmp23_[1];
						_tmp25_ = g_strdup (_tmp24_);
						value = _tmp25_;
						_tmp26_ = setting;
						_tmp27_ = permissions_backend_permission_settings_get_enabled (_tmp26_);
						_tmp28_ = _tmp27_;
						if (!_tmp28_) {
							const gchar* _tmp29_;
							gchar* _tmp30_;
							_tmp29_ = value;
							_tmp30_ = g_strdup_printf ("!%s", _tmp29_);
							_g_free0 (value);
							value = _tmp30_;
						}
						_tmp31_ = key_file;
						if (g_key_file_has_group (_tmp31_, PERMISSIONS_BACKEND_APP_GROUP)) {
							{
								gchar* _tmp32_ = NULL;
								GKeyFile* _tmp33_;
								const gchar* _tmp34_;
								gchar* _tmp35_;
								const gchar* _tmp36_;
								gchar* _tmp37_;
								_tmp33_ = key_file;
								_tmp34_ = key;
								_tmp35_ = g_key_file_get_value (_tmp33_, PERMISSIONS_BACKEND_APP_GROUP, _tmp34_, &_inner_error0_);
								_tmp32_ = _tmp35_;
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
									if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
										goto __catch1_g_key_file_error;
									}
									_g_free0 (value);
									_g_free0 (key);
									key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
									_g_object_unref0 (setting);
									_g_key_file_unref0 (key_file);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
								_tmp36_ = value;
								_tmp37_ = g_strdup_printf ("%s;%s", _tmp32_, _tmp36_);
								_g_free0 (value);
								value = _tmp37_;
								_g_free0 (_tmp32_);
							}
							goto __finally1;
							__catch1_g_key_file_error:
							{
								GError* e = NULL;
								GError* _tmp38_;
								const gchar* _tmp39_;
								e = _inner_error0_;
								_inner_error0_ = NULL;
								_tmp38_ = e;
								_tmp39_ = _tmp38_->message;
								g_debug ("App.vala:192: %s", _tmp39_);
								_g_error_free0 (e);
							}
							__finally1:
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								_g_free0 (value);
								_g_free0 (key);
								key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
								_g_object_unref0 (setting);
								_g_key_file_unref0 (key_file);
								if (_inner_error0_->domain == G_FILE_ERROR) {
									goto __catch0_g_file_error;
								}
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return;
							}
						}
						_tmp40_ = key_file;
						_tmp41_ = key;
						_tmp42_ = value;
						g_key_file_set_value (_tmp40_, PERMISSIONS_BACKEND_APP_GROUP, _tmp41_, _tmp42_);
						_g_free0 (value);
						_g_free0 (key);
						key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
					}
					_g_object_unref0 (setting);
				}
			}
		}
		_tmp43_ = key_file;
		_tmp44_ = permissions_backend_app_get_overrides_path (self);
		_tmp45_ = _tmp44_;
		g_key_file_save_to_file (_tmp43_, _tmp45_, &_inner_error0_);
		_g_free0 (_tmp45_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_key_file_unref0 (key_file);
			if (_inner_error0_->domain == G_FILE_ERROR) {
				goto __catch0_g_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_key_file_unref0 (key_file);
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp46_;
		const gchar* _tmp47_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp46_ = e;
		_tmp47_ = _tmp46_->message;
		g_debug ("App.vala:202: %s", _tmp47_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static GPtrArray*
permissions_backend_app_get_permissions_for_keyfile (PermissionsBackendApp* self,
                                                     GKeyFile* key_file)
{
	GPtrArray* permissions = NULL;
	GPtrArray* _tmp0_;
	GError* _inner_error0_ = NULL;
	GPtrArray* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (key_file != NULL, NULL);
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
	permissions = _tmp0_;
	if (!g_key_file_has_group (key_file, PERMISSIONS_BACKEND_APP_GROUP)) {
		result = permissions;
		return result;
	}
	{
		gchar** keys = NULL;
		gsize _tmp1_ = 0;
		gchar** _tmp2_;
		gint keys_length1;
		gint _keys_size_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		_tmp2_ = g_key_file_get_keys (key_file, PERMISSIONS_BACKEND_APP_GROUP, &_tmp1_, &_inner_error0_);
		keys = _tmp2_;
		keys_length1 = _tmp1_;
		_keys_size_ = keys_length1;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = keys;
		_tmp3__length1 = keys_length1;
		{
			gchar** key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
			key_collection = _tmp3_;
			key_collection_length1 = _tmp3__length1;
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
				const gchar* key = NULL;
				key = key_collection[key_it];
				{
					gchar** values = NULL;
					const gchar* _tmp4_;
					gsize _tmp5_ = 0;
					gchar** _tmp6_;
					gint values_length1;
					gint _values_size_;
					gchar** _tmp7_;
					gint _tmp7__length1;
					_tmp4_ = key;
					_tmp6_ = g_key_file_get_string_list (key_file, PERMISSIONS_BACKEND_APP_GROUP, _tmp4_, &_tmp5_, &_inner_error0_);
					values = _tmp6_;
					values_length1 = _tmp5_;
					_values_size_ = values_length1;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
						goto __catch0_g_error;
					}
					_tmp7_ = values;
					_tmp7__length1 = values_length1;
					{
						gchar** value_collection = NULL;
						gint value_collection_length1 = 0;
						gint _value_collection_size_ = 0;
						gint value_it = 0;
						value_collection = _tmp7_;
						value_collection_length1 = _tmp7__length1;
						for (value_it = 0; value_it < value_collection_length1; value_it = value_it + 1) {
							const gchar* value = NULL;
							value = value_collection[value_it];
							{
								const gchar* _tmp8_;
								gint _tmp9_;
								gint _tmp10_;
								GPtrArray* _tmp11_;
								const gchar* _tmp12_;
								const gchar* _tmp13_;
								gchar* _tmp14_;
								_tmp8_ = value;
								_tmp9_ = strlen (_tmp8_);
								_tmp10_ = _tmp9_;
								if (_tmp10_ == 0) {
									break;
								}
								_tmp11_ = permissions;
								_tmp12_ = key;
								_tmp13_ = value;
								_tmp14_ = g_strdup_printf ("%s=%s", _tmp12_, _tmp13_);
								g_ptr_array_add (_tmp11_, _tmp14_);
							}
						}
					}
					values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
				}
			}
		}
		keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp15_ = e;
		_tmp16_ = _tmp15_->message;
		g_critical ("App.vala:227: %s", _tmp16_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_ptr_array_unref0 (permissions);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = permissions;
	return result;
}

FlatpakInstalledRef*
permissions_backend_app_get_installed_ref (PermissionsBackendApp* self)
{
	FlatpakInstalledRef* result;
	FlatpakInstalledRef* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_installed_ref;
	result = _tmp0_;
	return result;
}

static void
permissions_backend_app_set_installed_ref (PermissionsBackendApp* self,
                                           FlatpakInstalledRef* value)
{
	FlatpakInstalledRef* old_value;
	g_return_if_fail (self != NULL);
	old_value = permissions_backend_app_get_installed_ref (self);
	if (old_value != value) {
		FlatpakInstalledRef* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_installed_ref);
		self->priv->_installed_ref = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY]);
	}
}

const gchar*
permissions_backend_app_get_id (PermissionsBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_id;
	result = _tmp0_;
	return result;
}

static void
permissions_backend_app_set_id (PermissionsBackendApp* self,
                                const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = permissions_backend_app_get_id (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_id);
		self->priv->_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_ID_PROPERTY]);
	}
}

const gchar*
permissions_backend_app_get_name (PermissionsBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

static void
permissions_backend_app_set_name (PermissionsBackendApp* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = permissions_backend_app_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_NAME_PROPERTY]);
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		PermissionsBackendApp* self;
		self = _data4_->self;
		_g_ptr_array_unref0 (_data4_->current_permissions);
		_g_ptr_array_unref0 (_data4_->permissions);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static void
_permissions_backend_app___lambda30_ (Block4Data* _data4_,
                                      const gchar* key)
{
	PermissionsBackendApp* self;
	gboolean standard = FALSE;
	gboolean enabled = FALSE;
	PermissionsBackendPermissionSettings* s = NULL;
	PermissionsBackendPermissionSettings* _tmp18_;
	PermissionsBackendPermissionSettings* _tmp19_;
	GPtrArray* _tmp20_;
	PermissionsBackendPermissionSettings* _tmp21_;
	PermissionsBackendPermissionSettings* _tmp22_;
	self = _data4_->self;
	g_return_if_fail (key != NULL);
	standard = FALSE;
	enabled = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gchar* permission = NULL;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = _data4_->permissions;
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				_tmp5_ = _data4_->permissions;
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
				_tmp7_ = g_strdup ((const gchar*) _tmp6_);
				permission = _tmp7_;
				_tmp8_ = permission;
				if (g_strcmp0 (key, _tmp8_) == 0) {
					standard = TRUE;
					_g_free0 (permission);
					break;
				}
				_g_free0 (permission);
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gchar* permission = NULL;
				GPtrArray* _tmp14_;
				gconstpointer _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
				if (!_tmp9_) {
					gint _tmp10_;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp11_ = _data4_->current_permissions;
				_tmp12_ = vala_g_ptr_array_get_length (_tmp11_);
				_tmp13_ = _tmp12_;
				if (!(i < _tmp13_)) {
					break;
				}
				_tmp14_ = _data4_->current_permissions;
				_tmp15_ = g_ptr_array_index (_tmp14_, (guint) i);
				_tmp16_ = g_strdup ((const gchar*) _tmp15_);
				permission = _tmp16_;
				_tmp17_ = permission;
				if (g_strcmp0 (key, _tmp17_) == 0) {
					enabled = TRUE;
					_g_free0 (permission);
					break;
				}
				_g_free0 (permission);
			}
		}
	}
	_tmp18_ = permissions_backend_permission_settings_new (key, standard);
	s = _tmp18_;
	_tmp19_ = s;
	permissions_backend_permission_settings_set_enabled (_tmp19_, enabled);
	_tmp20_ = self->settings;
	_tmp21_ = s;
	_tmp22_ = _g_object_ref0 (_tmp21_);
	g_ptr_array_add (_tmp20_, _tmp22_);
	_g_object_unref0 (s);
}

static void
__permissions_backend_app___lambda30__gh_func (gconstpointer key,
                                               gconstpointer value,
                                               gpointer self)
{
	_permissions_backend_app___lambda30_ (self, (const gchar*) key);
}

static void
_permissions_backend_app_save_overrides_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
	permissions_backend_app_save_overrides ((PermissionsBackendApp*) self);
}

static GObject *
permissions_backend_app_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PermissionsBackendApp * self;
	Block4Data* _data4_;
	FlatpakInstalledRef* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	FlatpakInstalledRef* _tmp3_;
	const gchar* _tmp4_;
	GPtrArray* _tmp6_;
	GPtrArray* _tmp7_;
	GPtrArray* overrides = NULL;
	GPtrArray* _tmp21_;
	GPtrArray* _tmp32_;
	GHashTable* _tmp58_;
	GHashTable* _tmp59_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (permissions_backend_app_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = self->priv->_installed_ref;
	_tmp1_ = flatpak_ref_get_name ((FlatpakRef*) _tmp0_);
	permissions_backend_app_set_id (self, _tmp1_);
	_tmp3_ = self->priv->_installed_ref;
	_tmp4_ = flatpak_installed_ref_get_appdata_name (_tmp3_);
	_tmp2_ = _tmp4_;
	if (_tmp2_ == NULL) {
		const gchar* _tmp5_;
		_tmp5_ = self->priv->_id;
		_tmp2_ = _tmp5_;
	}
	permissions_backend_app_set_name (self, _tmp2_);
	_tmp6_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
	_g_ptr_array_unref0 (self->settings);
	self->settings = _tmp6_;
	_tmp7_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
	_data4_->permissions = _tmp7_;
	{
		GBytes* metadata = NULL;
		FlatpakInstalledRef* _tmp8_;
		GBytes* _tmp9_;
		_tmp8_ = self->priv->_installed_ref;
		_tmp9_ = flatpak_installed_ref_load_metadata (_tmp8_, NULL, &_inner_error0_);
		metadata = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		{
			GKeyFile* key_file = NULL;
			GKeyFile* _tmp10_;
			GKeyFile* _tmp11_;
			GBytes* _tmp12_;
			GKeyFile* _tmp13_;
			GPtrArray* _tmp14_;
			_tmp10_ = g_key_file_new ();
			key_file = _tmp10_;
			_tmp11_ = key_file;
			_tmp12_ = metadata;
			g_key_file_load_from_bytes (_tmp11_, _tmp12_, G_KEY_FILE_NONE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_key_file_unref0 (key_file);
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
					goto __catch1_g_key_file_error;
				}
				if (_inner_error0_->domain == G_FILE_ERROR) {
					goto __catch1_g_file_error;
				}
				_g_bytes_unref0 (metadata);
				block4_data_unref (_data4_);
				_data4_ = NULL;
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
			}
			_tmp13_ = key_file;
			_tmp14_ = permissions_backend_app_get_permissions_for_keyfile (self, _tmp13_);
			_g_ptr_array_unref0 (_data4_->permissions);
			_data4_->permissions = _tmp14_;
			_g_key_file_unref0 (key_file);
		}
		goto __finally1;
		__catch1_g_key_file_error:
		{
			GError* e = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp15_ = e;
			_tmp16_ = _tmp15_->message;
			g_debug ("App.vala:50: Couldn't create permissions keyfile: %s", _tmp16_);
			_g_error_free0 (e);
		}
		goto __finally1;
		__catch1_g_file_error:
		{
			GError* e = NULL;
			GError* _tmp17_;
			const gchar* _tmp18_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp17_ = e;
			_tmp18_ = _tmp17_->message;
			g_debug ("App.vala:52: Couldn't load permissions file: %s", _tmp18_);
			_g_error_free0 (e);
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_bytes_unref0 (metadata);
			goto __catch0_g_error;
		}
		_g_bytes_unref0 (metadata);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp19_ = e;
		_tmp20_ = _tmp19_->message;
		g_critical ("App.vala:55: Couldn't load metadata: %s", _tmp20_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		block4_data_unref (_data4_);
		_data4_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	_tmp21_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
	overrides = _tmp21_;
	{
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp22_;
		GKeyFile* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GKeyFile* _tmp26_;
		GPtrArray* _tmp27_;
		_tmp22_ = g_key_file_new ();
		key_file = _tmp22_;
		_tmp23_ = key_file;
		_tmp24_ = permissions_backend_app_get_overrides_path (self);
		_tmp25_ = _tmp24_;
		g_key_file_load_from_file (_tmp23_, _tmp25_, G_KEY_FILE_NONE, &_inner_error0_);
		_g_free0 (_tmp25_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_key_file_unref0 (key_file);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch2_g_key_file_error;
			}
			if (_inner_error0_->domain == G_FILE_ERROR) {
				goto __catch2_g_file_error;
			}
			_g_ptr_array_unref0 (overrides);
			block4_data_unref (_data4_);
			_data4_ = NULL;
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
		}
		_tmp26_ = key_file;
		_tmp27_ = permissions_backend_app_get_permissions_for_keyfile (self, _tmp26_);
		_g_ptr_array_unref0 (overrides);
		overrides = _tmp27_;
		_g_key_file_unref0 (key_file);
	}
	goto __finally2;
	__catch2_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp28_;
		const gchar* _tmp29_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp28_ = e;
		_tmp29_ = _tmp28_->message;
		g_debug ("App.vala:65: Couldn't create overrides keyfile: %s", _tmp29_);
		_g_error_free0 (e);
	}
	goto __finally2;
	__catch2_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp30_ = e;
		_tmp31_ = _tmp30_->message;
		g_debug ("App.vala:67: Couldn't load overrides file: %s", _tmp31_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_ptr_array_unref0 (overrides);
		block4_data_unref (_data4_);
		_data4_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	_tmp32_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
	_data4_->current_permissions = _tmp32_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp33_ = FALSE;
			_tmp33_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				gchar* permission = NULL;
				GPtrArray* _tmp38_;
				gconstpointer _tmp39_;
				gchar* _tmp40_;
				GPtrArray* _tmp41_;
				const gchar* _tmp42_;
				GPtrArray* _tmp43_;
				const gchar* _tmp44_;
				gchar* _tmp45_;
				if (!_tmp33_) {
					gint _tmp34_;
					_tmp34_ = i;
					i = _tmp34_ + 1;
				}
				_tmp33_ = FALSE;
				_tmp35_ = _data4_->permissions;
				_tmp36_ = vala_g_ptr_array_get_length (_tmp35_);
				_tmp37_ = _tmp36_;
				if (!(i < _tmp37_)) {
					break;
				}
				_tmp38_ = _data4_->permissions;
				_tmp39_ = g_ptr_array_index (_tmp38_, (guint) i);
				_tmp40_ = g_strdup ((const gchar*) _tmp39_);
				permission = _tmp40_;
				_tmp41_ = overrides;
				_tmp42_ = permission;
				if (permissions_backend_app_is_permission_overridden (self, _tmp41_, _tmp42_)) {
					_g_free0 (permission);
					continue;
				}
				_tmp43_ = _data4_->current_permissions;
				_tmp44_ = permission;
				_tmp45_ = g_strdup (_tmp44_);
				g_ptr_array_add (_tmp43_, _tmp45_);
				_g_free0 (permission);
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp46_ = FALSE;
			_tmp46_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp48_;
				gint _tmp49_;
				gint _tmp50_;
				gchar* permission = NULL;
				GPtrArray* _tmp51_;
				gconstpointer _tmp52_;
				gchar* _tmp53_;
				const gchar* _tmp54_;
				GPtrArray* _tmp55_;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				if (!_tmp46_) {
					gint _tmp47_;
					_tmp47_ = i;
					i = _tmp47_ + 1;
				}
				_tmp46_ = FALSE;
				_tmp48_ = overrides;
				_tmp49_ = vala_g_ptr_array_get_length (_tmp48_);
				_tmp50_ = _tmp49_;
				if (!(i < _tmp50_)) {
					break;
				}
				_tmp51_ = overrides;
				_tmp52_ = g_ptr_array_index (_tmp51_, (guint) i);
				_tmp53_ = g_strdup ((const gchar*) _tmp52_);
				permission = _tmp53_;
				_tmp54_ = permission;
				if (string_contains (_tmp54_, "=!")) {
					_g_free0 (permission);
					continue;
				}
				_tmp55_ = _data4_->current_permissions;
				_tmp56_ = permission;
				_tmp57_ = g_strdup (_tmp56_);
				g_ptr_array_add (_tmp55_, _tmp57_);
				_g_free0 (permission);
			}
		}
	}
	_tmp58_ = permissions_plug_get_permission_names ();
	_tmp59_ = _tmp58_;
	g_hash_table_foreach (_tmp59_, __permissions_backend_app___lambda30__gh_func, _data4_);
	g_signal_connect_object ((GObject*) self, "notify::settings", (GCallback) _permissions_backend_app_save_overrides_g_object_notify, self, 0);
	permissions_backend_app_save_overrides (self);
	_g_ptr_array_unref0 (overrides);
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return obj;
}

static void
permissions_backend_app_class_init (PermissionsBackendAppClass * klass,
                                    gpointer klass_data)
{
	permissions_backend_app_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PermissionsBackendApp_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_permissions_backend_app_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_permissions_backend_app_set_property;
	G_OBJECT_CLASS (klass)->constructor = permissions_backend_app_constructor;
	G_OBJECT_CLASS (klass)->finalize = permissions_backend_app_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY] = g_param_spec_object ("installed-ref", "installed-ref", "installed-ref", flatpak_installed_ref_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_ID_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_NAME_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
permissions_backend_app_instance_init (PermissionsBackendApp * self,
                                       gpointer klass)
{
	self->priv = permissions_backend_app_get_instance_private (self);
}

static void
permissions_backend_app_finalize (GObject * obj)
{
	PermissionsBackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
	_g_object_unref0 (self->priv->_installed_ref);
	_g_free0 (self->priv->_id);
	_g_free0 (self->priv->_name);
	_g_ptr_array_unref0 (self->settings);
	G_OBJECT_CLASS (permissions_backend_app_parent_class)->finalize (obj);
}

static GType
permissions_backend_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PermissionsBackendAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) permissions_backend_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PermissionsBackendApp), 0, (GInstanceInitFunc) permissions_backend_app_instance_init, NULL };
	GType permissions_backend_app_type_id;
	permissions_backend_app_type_id = g_type_register_static (G_TYPE_OBJECT, "PermissionsBackendApp", &g_define_type_info, 0);
	PermissionsBackendApp_private_offset = g_type_add_instance_private (permissions_backend_app_type_id, sizeof (PermissionsBackendAppPrivate));
	return permissions_backend_app_type_id;
}

GType
permissions_backend_app_get_type (void)
{
	static volatile gsize permissions_backend_app_type_id__volatile = 0;
	if (g_once_init_enter (&permissions_backend_app_type_id__volatile)) {
		GType permissions_backend_app_type_id;
		permissions_backend_app_type_id = permissions_backend_app_get_type_once ();
		g_once_init_leave (&permissions_backend_app_type_id__volatile, permissions_backend_app_type_id);
	}
	return permissions_backend_app_type_id__volatile;
}

static void
_vala_permissions_backend_app_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	PermissionsBackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
	switch (property_id) {
		case PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY:
		g_value_set_object (value, permissions_backend_app_get_installed_ref (self));
		break;
		case PERMISSIONS_BACKEND_APP_ID_PROPERTY:
		g_value_set_string (value, permissions_backend_app_get_id (self));
		break;
		case PERMISSIONS_BACKEND_APP_NAME_PROPERTY:
		g_value_set_string (value, permissions_backend_app_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_permissions_backend_app_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	PermissionsBackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
	switch (property_id) {
		case PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY:
		permissions_backend_app_set_installed_ref (self, g_value_get_object (value));
		break;
		case PERMISSIONS_BACKEND_APP_ID_PROPERTY:
		permissions_backend_app_set_id (self, g_value_get_string (value));
		break;
		case PERMISSIONS_BACKEND_APP_NAME_PROPERTY:
		permissions_backend_app_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

