/* Startup.c generated by valac 0.52.4, the Vala compiler
 * generated from Startup.vala, do not modify */

/*
* Copyright 2013-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Akshay Shekher <voldyman666@gmail.com>
*              Julien Spautz <spautz.julien@gmail.com>
*/

#include "applications.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gstdio.h>
#include <gdk/gdk.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

enum  {
	STARTUP_PLUG_0_PROPERTY,
	STARTUP_PLUG_NUM_PROPERTIES
};
static GParamSpec* startup_plug_properties[STARTUP_PLUG_NUM_PROPERTIES];
typedef enum  {
	STARTUP_PLUG_TARGET_URI_LIST
} StartupPlugTarget;

#define STARTUP_PLUG_TYPE_TARGET (startup_plug_target_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _StartupPlugPrivate {
	StartupController* controller;
	GtkListBox* list;
	StartupWidgetsAppChooser* app_chooser;
};

struct _Block1Data {
	int _ref_count_;
	StartupPlug* self;
	StartupBackendKeyFile* key_file;
};

struct _Block2Data {
	int _ref_count_;
	StartupPlug* self;
	GtkButton* remove_button;
};

static gint StartupPlug_private_offset;
static gpointer startup_plug_parent_class = NULL;

static GType startup_plug_target_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda21_ (Block1Data* _data1_,
                  gboolean active);
static void ___lambda21__startup_widgets_app_row_active_changed (StartupWidgetsAppRow* _sender,
                                                          gboolean active,
                                                          gpointer self);
static void startup_plug_create_file (StartupPlug* self,
                               const gchar* path);
StartupBackendKeyFile* startup_backend_key_file_factory_get_or_create (const gchar* path);
static void startup_plug_remove_selected_app (StartupPlug* self);
static gchar* startup_plug_get_path_from_uri (StartupPlug* self,
                                       const gchar* uri);
static gint startup_plug_sort_function (StartupPlug* self,
                                 GtkListBoxRow* row1,
                                 GtkListBoxRow* row2);
static void startup_plug_on_drag_data_received (StartupPlug* self,
                                         GdkDragContext* context,
                                         gint x,
                                         gint y,
                                         GtkSelectionData* selection_data,
                                         guint info,
                                         guint time_);
static GObject * startup_plug_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
void startup_backend_key_file_factory_init (void);
static gint _startup_plug_sort_function_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                         GtkListBoxRow* row2,
                                                         gpointer self);
static void _startup_plug___lambda23_ (StartupPlug* self);
static void __startup_plug___lambda23__gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self);
static void _startup_plug___lambda24_ (StartupPlug* self,
                                const gchar* path);
static void __startup_plug___lambda24__startup_widgets_app_chooser_app_chosen (StartupWidgetsAppChooser* _sender,
                                                                        const gchar* path,
                                                                        gpointer self);
static void _startup_plug___lambda25_ (StartupPlug* self,
                                const gchar* command);
static void __startup_plug___lambda25__startup_widgets_app_chooser_custom_command_chosen (StartupWidgetsAppChooser* _sender,
                                                                                   const gchar* command,
                                                                                   gpointer self);
static void _startup_plug_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                        GdkDragContext* context,
                                                                        gint x,
                                                                        gint y,
                                                                        GtkSelectionData* selection_data,
                                                                        guint info,
                                                                        guint time_,
                                                                        gpointer self);
static void _startup_plug___lambda26_ (Block2Data* _data2_,
                                GtkListBoxRow* row);
static void __startup_plug___lambda26__gtk_list_box_row_selected (GtkListBox* _sender,
                                                           GtkListBoxRow* row,
                                                           gpointer self);
static void _startup_plug___lambda27_ (StartupPlug* self,
                                const gchar* path);
static void __startup_plug___lambda27__startup_backend_monitor_file_created (StartupBackendMonitor* _sender,
                                                                      const gchar* path,
                                                                      gpointer self);
static void _startup_plug___lambda28_ (StartupPlug* self,
                                const gchar* path);
static void __startup_plug___lambda28__startup_backend_monitor_file_deleted (StartupBackendMonitor* _sender,
                                                                      const gchar* path,
                                                                      gpointer self);
static void _startup_plug___lambda29_ (StartupPlug* self);
static void __startup_plug___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self);
static void startup_plug_finalize (GObject * obj);
static GType startup_plug_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GtkTargetEntry STARTUP_PLUG_TARGET_LIST[1] = {{"text/uri-list", (guint) 0, (guint) STARTUP_PLUG_TARGET_URI_LIST}};

static inline gpointer
startup_plug_get_instance_private (StartupPlug* self)
{
	return G_STRUCT_MEMBER_P (self, StartupPlug_private_offset);
}

static GType
startup_plug_target_get_type_once (void)
{
	static const GEnumValue values[] = {{STARTUP_PLUG_TARGET_URI_LIST, "STARTUP_PLUG_TARGET_URI_LIST", "uri-list"}, {0, NULL, NULL}};
	GType startup_plug_target_type_id;
	startup_plug_target_type_id = g_enum_register_static ("StartupPlugTarget", values);
	return startup_plug_target_type_id;
}

static GType
startup_plug_target_get_type (void)
{
	static volatile gsize startup_plug_target_type_id__volatile = 0;
	if (g_once_init_enter (&startup_plug_target_type_id__volatile)) {
		GType startup_plug_target_type_id;
		startup_plug_target_type_id = startup_plug_target_get_type_once ();
		g_once_init_leave (&startup_plug_target_type_id__volatile, startup_plug_target_type_id);
	}
	return startup_plug_target_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		StartupPlug* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->key_file);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda21_ (Block1Data* _data1_,
             gboolean active)
{
	StartupPlug* self;
	self = _data1_->self;
	startup_backend_key_file_set_active (_data1_->key_file, active);
	startup_backend_key_file_write_to_file (_data1_->key_file);
}

static void
___lambda21__startup_widgets_app_row_active_changed (StartupWidgetsAppRow* _sender,
                                                     gboolean active,
                                                     gpointer self)
{
	__lambda21_ (self, active);
}

void
startup_plug_add_app (StartupPlug* self,
                      StartupBackendKeyFile* key_file)
{
	Block1Data* _data1_;
	StartupBackendKeyFile* _tmp0_;
	StartupEntityAppInfo app_info = {0};
	StartupEntityAppInfo _tmp1_ = {0};
	GtkListBox* _tmp2_;
	GList* _tmp3_;
	StartupWidgetsAppRow* row = NULL;
	StartupEntityAppInfo _tmp8_;
	StartupWidgetsAppRow* _tmp9_;
	GtkListBox* _tmp10_;
	StartupWidgetsAppRow* _tmp11_;
	StartupWidgetsAppRow* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key_file != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (key_file);
	_g_object_unref0 (_data1_->key_file);
	_data1_->key_file = _tmp0_;
	startup_backend_key_file_create_app_info (_data1_->key_file, &_tmp1_);
	app_info = _tmp1_;
	_tmp2_ = self->priv->list;
	_tmp3_ = gtk_container_get_children ((GtkContainer*) _tmp2_);
	{
		GList* app_row_collection = NULL;
		GList* app_row_it = NULL;
		app_row_collection = _tmp3_;
		for (app_row_it = app_row_collection; app_row_it != NULL; app_row_it = app_row_it->next) {
			GtkWidget* app_row = NULL;
			app_row = (GtkWidget*) app_row_it->data;
			{
				GtkWidget* _tmp4_;
				StartupEntityAppInfo _tmp5_ = {0};
				StartupEntityAppInfo _tmp6_;
				StartupEntityAppInfo _tmp7_;
				_tmp4_ = app_row;
				startup_widgets_app_row_get_app_info (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow), &_tmp5_);
				_tmp6_ = _tmp5_;
				_tmp7_ = app_info;
				if (startup_entity_app_info_equal (&_tmp6_, &_tmp7_)) {
					(app_row_collection == NULL) ? NULL : (app_row_collection = (g_list_free (app_row_collection), NULL));
					startup_entity_app_info_destroy (&app_info);
					block1_data_unref (_data1_);
					_data1_ = NULL;
					return;
				}
			}
		}
		(app_row_collection == NULL) ? NULL : (app_row_collection = (g_list_free (app_row_collection), NULL));
	}
	_tmp8_ = app_info;
	_tmp9_ = startup_widgets_app_row_new (&_tmp8_);
	g_object_ref_sink (_tmp9_);
	row = _tmp9_;
	_tmp10_ = self->priv->list;
	_tmp11_ = row;
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = row;
	g_signal_connect_data (_tmp12_, "active-changed", (GCallback) ___lambda21__startup_widgets_app_row_active_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_g_object_unref0 (row);
	startup_entity_app_info_destroy (&app_info);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

void
startup_plug_remove_app_from_path (StartupPlug* self,
                                   const gchar* path)
{
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->list;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	{
		GList* app_row_collection = NULL;
		GList* app_row_it = NULL;
		app_row_collection = _tmp1_;
		for (app_row_it = app_row_collection; app_row_it != NULL; app_row_it = app_row_it->next) {
			GtkWidget* app_row = NULL;
			app_row = (GtkWidget*) app_row_it->data;
			{
				GtkWidget* _tmp2_;
				StartupEntityAppInfo _tmp3_ = {0};
				StartupEntityAppInfo _tmp4_;
				const gchar* _tmp5_;
				_tmp2_ = app_row;
				startup_widgets_app_row_get_app_info (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow), &_tmp3_);
				_tmp4_ = _tmp3_;
				_tmp5_ = _tmp4_.path;
				if (g_strcmp0 (_tmp5_, path) == 0) {
					GtkListBox* _tmp6_;
					GtkWidget* _tmp7_;
					_tmp6_ = self->priv->list;
					_tmp7_ = app_row;
					gtk_container_remove ((GtkContainer*) _tmp6_, _tmp7_);
				}
			}
		}
		(app_row_collection == NULL) ? NULL : (app_row_collection = (g_list_free (app_row_collection), NULL));
	}
}

void
startup_plug_init_app_chooser (StartupPlug* self,
                               GeeCollection* app_infos)
{
	StartupWidgetsAppChooser* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (app_infos != NULL);
	_tmp0_ = self->priv->app_chooser;
	startup_widgets_app_chooser_init_list (_tmp0_, app_infos);
}

static void
startup_plug_create_file (StartupPlug* self,
                          const gchar* path)
{
	StartupBackendKeyFile* key_file = NULL;
	StartupBackendKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = startup_backend_key_file_factory_get_or_create (path);
	key_file = _tmp0_;
	startup_backend_key_file_set_active (key_file, TRUE);
	startup_backend_key_file_copy_to_local (key_file);
	startup_plug_add_app (self, key_file);
	_g_object_unref0 (key_file);
}

static void
startup_plug_remove_selected_app (StartupPlug* self)
{
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GtkListBoxRow* _tmp2_;
	GtkListBoxRow* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBoxRow* _tmp5_;
	GtkListBoxRow* _tmp6_;
	StartupEntityAppInfo _tmp7_ = {0};
	StartupEntityAppInfo _tmp8_;
	const gchar* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->list;
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	row = _tmp2_;
	_tmp3_ = row;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (row);
		return;
	}
	_tmp4_ = self->priv->list;
	_tmp5_ = row;
	gtk_container_remove ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = row;
	startup_widgets_app_row_get_app_info (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow), &_tmp7_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _tmp8_.path;
	g_remove (_tmp9_);
	_g_object_unref0 (row);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static gchar*
startup_plug_get_path_from_uri (StartupPlug* self,
                                const gchar* uri)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	if (g_str_has_prefix (uri, "#")) {
		_tmp0_ = TRUE;
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = string_strip (uri);
		_tmp2_ = _tmp1_;
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
		_g_free0 (_tmp2_);
	}
	if (_tmp0_) {
		result = NULL;
		return result;
	}
	{
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = g_filename_from_uri (uri, NULL, &_inner_error0_);
		_tmp3_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp5_ = _tmp3_;
		_tmp3_ = NULL;
		result = _tmp5_;
		_g_free0 (_tmp3_);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		g_warning ("Startup.vala:173: Could not convert URI of dropped item to filename");
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("Startup.vala:174: %s", _tmp7_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = NULL;
	return result;
}

static gint
startup_plug_sort_function (StartupPlug* self,
                            GtkListBoxRow* row1,
                            GtkListBoxRow* row2)
{
	gchar* name_1 = NULL;
	StartupEntityAppInfo _tmp0_ = {0};
	StartupEntityAppInfo _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* name_2 = NULL;
	StartupEntityAppInfo _tmp4_ = {0};
	StartupEntityAppInfo _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	startup_widgets_app_row_get_app_info (G_TYPE_CHECK_INSTANCE_CAST (row1, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow), &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_.name;
	_tmp3_ = g_strdup (_tmp2_);
	name_1 = _tmp3_;
	startup_widgets_app_row_get_app_info (G_TYPE_CHECK_INSTANCE_CAST (row2, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow), &_tmp4_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_.name;
	_tmp7_ = g_strdup (_tmp6_);
	name_2 = _tmp7_;
	result = g_utf8_collate (name_1, name_2);
	_g_free0 (name_2);
	_g_free0 (name_1);
	return result;
}

static void
startup_plug_on_drag_data_received (StartupPlug* self,
                                    GdkDragContext* context,
                                    gint x,
                                    gint y,
                                    GtkSelectionData* selection_data,
                                    guint info,
                                    guint time_)
{
	gchar* uris = NULL;
	guint8* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	if (info != ((guint) STARTUP_PLUG_TARGET_URI_LIST)) {
		return;
	}
	_tmp0_ = gtk_selection_data_get_data (selection_data);
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	uris = _tmp1_;
	_tmp2_ = uris;
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\r\n", 0);
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
		uri_collection = _tmp4_;
		uri_collection_length1 = _vala_array_length (_tmp3_);
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
			const gchar* uri = NULL;
			uri = uri_collection[uri_it];
			{
				gchar* path = NULL;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				const gchar* _tmp7_;
				_tmp5_ = uri;
				_tmp6_ = startup_plug_get_path_from_uri (self, _tmp5_);
				path = _tmp6_;
				_tmp7_ = path;
				if (_tmp7_ != NULL) {
					const gchar* _tmp8_;
					_tmp8_ = path;
					startup_plug_create_file (self, _tmp8_);
				}
				_g_free0 (path);
			}
		}
		uri_collection = (_vala_array_free (uri_collection, uri_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_free0 (uris);
}

StartupPlug*
startup_plug_construct (GType object_type)
{
	StartupPlug * self = NULL;
	self = (StartupPlug*) g_object_new (object_type, NULL);
	return self;
}

StartupPlug*
startup_plug_new (void)
{
	return startup_plug_construct (STARTUP_TYPE_PLUG);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		StartupPlug* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->remove_button);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gint
_startup_plug_sort_function_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                    GtkListBoxRow* row2,
                                                    gpointer self)
{
	gint result;
	result = startup_plug_sort_function ((StartupPlug*) self, row1, row2);
	return result;
}

static void
_startup_plug___lambda23_ (StartupPlug* self)
{
	StartupWidgetsAppChooser* _tmp0_;
	_tmp0_ = self->priv->app_chooser;
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
}

static void
__startup_plug___lambda23__gtk_button_clicked (GtkButton* _sender,
                                               gpointer self)
{
	_startup_plug___lambda23_ ((StartupPlug*) self);
}

static void
_startup_plug___lambda24_ (StartupPlug* self,
                           const gchar* path)
{
	g_return_if_fail (path != NULL);
	startup_plug_create_file (self, path);
}

static void
__startup_plug___lambda24__startup_widgets_app_chooser_app_chosen (StartupWidgetsAppChooser* _sender,
                                                                   const gchar* path,
                                                                   gpointer self)
{
	_startup_plug___lambda24_ ((StartupPlug*) self, path);
}

static void
_startup_plug___lambda25_ (StartupPlug* self,
                           const gchar* command)
{
	StartupBackendKeyFile* _tmp0_;
	StartupBackendKeyFile* _tmp1_;
	g_return_if_fail (command != NULL);
	_tmp0_ = startup_backend_key_file_new_from_command (command);
	_tmp1_ = _tmp0_;
	startup_plug_add_app (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
}

static void
__startup_plug___lambda25__startup_widgets_app_chooser_custom_command_chosen (StartupWidgetsAppChooser* _sender,
                                                                              const gchar* command,
                                                                              gpointer self)
{
	_startup_plug___lambda25_ ((StartupPlug*) self, command);
}

static void
_startup_plug_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   gint x,
                                                                   gint y,
                                                                   GtkSelectionData* selection_data,
                                                                   guint info,
                                                                   guint time_,
                                                                   gpointer self)
{
	startup_plug_on_drag_data_received ((StartupPlug*) self, context, x, y, selection_data, info, time_);
}

static void
_startup_plug___lambda26_ (Block2Data* _data2_,
                           GtkListBoxRow* row)
{
	StartupPlug* self;
	GtkButton* _tmp0_;
	self = _data2_->self;
	_tmp0_ = _data2_->remove_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, row != NULL);
}

static void
__startup_plug___lambda26__gtk_list_box_row_selected (GtkListBox* _sender,
                                                      GtkListBoxRow* row,
                                                      gpointer self)
{
	_startup_plug___lambda26_ (self, row);
}

static void
_startup_plug___lambda27_ (StartupPlug* self,
                           const gchar* path)
{
	StartupBackendKeyFile* _tmp0_;
	StartupBackendKeyFile* _tmp1_;
	g_return_if_fail (path != NULL);
	_tmp0_ = startup_backend_key_file_factory_get_or_create (path);
	_tmp1_ = _tmp0_;
	startup_plug_add_app (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
}

static void
__startup_plug___lambda27__startup_backend_monitor_file_created (StartupBackendMonitor* _sender,
                                                                 const gchar* path,
                                                                 gpointer self)
{
	_startup_plug___lambda27_ ((StartupPlug*) self, path);
}

static void
_startup_plug___lambda28_ (StartupPlug* self,
                           const gchar* path)
{
	g_return_if_fail (path != NULL);
	startup_plug_remove_app_from_path (self, path);
}

static void
__startup_plug___lambda28__startup_backend_monitor_file_deleted (StartupBackendMonitor* _sender,
                                                                 const gchar* path,
                                                                 gpointer self)
{
	_startup_plug___lambda28_ ((StartupPlug*) self, path);
}

static void
_startup_plug___lambda29_ (StartupPlug* self)
{
	startup_plug_remove_selected_app (self);
}

static void
__startup_plug___lambda29__gtk_button_clicked (GtkButton* _sender,
                                               gpointer self)
{
	_startup_plug___lambda29_ ((StartupPlug*) self);
}

static GObject *
startup_plug_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	StartupPlug * self;
	Block2Data* _data2_;
	GraniteWidgetsAlertView* empty_alert = NULL;
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	GtkListBox* _tmp2_ = NULL;
	GtkListBox* _tmp3_;
	GraniteWidgetsAlertView* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp7_;
	GtkScrolledWindow* _tmp8_;
	GtkListBox* _tmp9_;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp10_;
	GtkActionBar* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkButton* add_button = NULL;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
	GtkActionBar* _tmp18_;
	GtkButton* _tmp19_;
	GtkActionBar* _tmp20_;
	GtkButton* _tmp21_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkScrolledWindow* _tmp24_;
	GtkGrid* _tmp25_;
	GtkActionBar* _tmp26_;
	GtkFrame* frame = NULL;
	GtkFrame* _tmp27_;
	GtkFrame* _tmp28_;
	GtkGrid* _tmp29_;
	GtkFrame* _tmp30_;
	GtkButton* _tmp31_;
	StartupWidgetsAppChooser* _tmp32_;
	StartupWidgetsAppChooser* _tmp33_;
	StartupBackendMonitor* monitor = NULL;
	StartupBackendMonitor* _tmp34_;
	StartupController* _tmp35_;
	GtkButton* _tmp36_;
	StartupWidgetsAppChooser* _tmp37_;
	StartupWidgetsAppChooser* _tmp38_;
	GtkListBox* _tmp39_;
	GtkListBox* _tmp40_;
	StartupBackendMonitor* _tmp41_;
	StartupBackendMonitor* _tmp42_;
	GtkButton* _tmp43_;
	parent_class = G_OBJECT_CLASS (startup_plug_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_TYPE_PLUG, StartupPlug);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	startup_backend_key_file_factory_init ();
	_tmp0_ = granite_widgets_alert_view_new (_ ("Launch Apps on Startup"), _ ("Add apps to the Startup list by clicking the icon in the toolbar below" \
"."), "system-restart");
	g_object_ref_sink (_tmp0_);
	empty_alert = _tmp0_;
	_tmp1_ = empty_alert;
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
	_tmp2_ = (GtkListBox*) gtk_list_box_new ();
	g_object_set ((GtkWidget*) _tmp2_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->list);
	self->priv->list = _tmp2_;
	_tmp3_ = self->priv->list;
	_tmp4_ = empty_alert;
	gtk_list_box_set_placeholder (_tmp3_, (GtkWidget*) _tmp4_);
	_tmp5_ = self->priv->list;
	gtk_list_box_set_sort_func (_tmp5_, _startup_plug_sort_function_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
	_tmp6_ = self->priv->list;
	gtk_drag_dest_set ((GtkWidget*) _tmp6_, GTK_DEST_DEFAULT_ALL, STARTUP_PLUG_TARGET_LIST, (gint) G_N_ELEMENTS (STARTUP_PLUG_TARGET_LIST), GDK_ACTION_COPY);
	_tmp7_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp7_);
	scrolled = _tmp7_;
	_tmp8_ = scrolled;
	_tmp9_ = self->priv->list;
	gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
	_tmp10_ = (GtkActionBar*) gtk_action_bar_new ();
	g_object_ref_sink (_tmp10_);
	actionbar = _tmp10_;
	_tmp11_ = actionbar;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	gtk_style_context_add_class (_tmp12_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("application-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp13_);
	add_button = _tmp13_;
	_tmp14_ = add_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _ ("Add Startup App…"));
	_tmp15_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp15_);
	_data2_->remove_button = _tmp15_;
	_tmp16_ = _data2_->remove_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp16_, _ ("Remove Selected Startup App"));
	_tmp17_ = _data2_->remove_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, FALSE);
	_tmp18_ = actionbar;
	_tmp19_ = add_button;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = actionbar;
	_tmp21_ = _data2_->remove_button;
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp22_);
	grid = _tmp22_;
	_tmp23_ = grid;
	_tmp24_ = scrolled;
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 0, 0, 1, 1);
	_tmp25_ = grid;
	_tmp26_ = actionbar;
	gtk_grid_attach (_tmp25_, (GtkWidget*) _tmp26_, 0, 1, 1, 1);
	_tmp27_ = (GtkFrame*) gtk_frame_new (NULL);
	g_object_ref_sink (_tmp27_);
	frame = _tmp27_;
	_tmp28_ = frame;
	_tmp29_ = grid;
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	g_object_set ((GtkWidget*) self, "margin", 12, NULL);
	gtk_widget_set_margin_top ((GtkWidget*) self, 0);
	_tmp30_ = frame;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp30_);
	_tmp31_ = add_button;
	_tmp32_ = startup_widgets_app_chooser_new ((GtkWidget*) _tmp31_);
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->priv->app_chooser);
	self->priv->app_chooser = _tmp32_;
	_tmp33_ = self->priv->app_chooser;
	gtk_popover_set_modal ((GtkPopover*) _tmp33_, TRUE);
	_tmp34_ = startup_backend_monitor_new ();
	monitor = _tmp34_;
	_tmp35_ = startup_controller_new (self);
	_g_object_unref0 (self->priv->controller);
	self->priv->controller = _tmp35_;
	_tmp36_ = add_button;
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) __startup_plug___lambda23__gtk_button_clicked, self, 0);
	_tmp37_ = self->priv->app_chooser;
	g_signal_connect_object (_tmp37_, "app-chosen", (GCallback) __startup_plug___lambda24__startup_widgets_app_chooser_app_chosen, self, 0);
	_tmp38_ = self->priv->app_chooser;
	g_signal_connect_object (_tmp38_, "custom-command-chosen", (GCallback) __startup_plug___lambda25__startup_widgets_app_chooser_custom_command_chosen, self, 0);
	_tmp39_ = self->priv->list;
	g_signal_connect_object ((GtkWidget*) _tmp39_, "drag-data-received", (GCallback) _startup_plug_on_drag_data_received_gtk_widget_drag_data_received, self, 0);
	_tmp40_ = self->priv->list;
	g_signal_connect_data (_tmp40_, "row-selected", (GCallback) __startup_plug___lambda26__gtk_list_box_row_selected, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp41_ = monitor;
	g_signal_connect_object (_tmp41_, "file-created", (GCallback) __startup_plug___lambda27__startup_backend_monitor_file_created, self, 0);
	_tmp42_ = monitor;
	g_signal_connect_object (_tmp42_, "file-deleted", (GCallback) __startup_plug___lambda28__startup_backend_monitor_file_deleted, self, 0);
	_tmp43_ = _data2_->remove_button;
	g_signal_connect_object (_tmp43_, "clicked", (GCallback) __startup_plug___lambda29__gtk_button_clicked, self, 0);
	_g_object_unref0 (monitor);
	_g_object_unref0 (frame);
	_g_object_unref0 (grid);
	_g_object_unref0 (add_button);
	_g_object_unref0 (actionbar);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (empty_alert);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return obj;
}

static void
startup_plug_class_init (StartupPlugClass * klass,
                         gpointer klass_data)
{
	startup_plug_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &StartupPlug_private_offset);
	G_OBJECT_CLASS (klass)->constructor = startup_plug_constructor;
	G_OBJECT_CLASS (klass)->finalize = startup_plug_finalize;
}

static void
startup_plug_instance_init (StartupPlug * self,
                            gpointer klass)
{
	self->priv = startup_plug_get_instance_private (self);
}

static void
startup_plug_finalize (GObject * obj)
{
	StartupPlug * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_TYPE_PLUG, StartupPlug);
	_g_object_unref0 (self->priv->controller);
	_g_object_unref0 (self->priv->list);
	_g_object_unref0 (self->priv->app_chooser);
	G_OBJECT_CLASS (startup_plug_parent_class)->finalize (obj);
}

static GType
startup_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StartupPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupPlug), 0, (GInstanceInitFunc) startup_plug_instance_init, NULL };
	GType startup_plug_type_id;
	startup_plug_type_id = g_type_register_static (gtk_grid_get_type (), "StartupPlug", &g_define_type_info, 0);
	StartupPlug_private_offset = g_type_add_instance_private (startup_plug_type_id, sizeof (StartupPlugPrivate));
	return startup_plug_type_id;
}

GType
startup_plug_get_type (void)
{
	static volatile gsize startup_plug_type_id__volatile = 0;
	if (g_once_init_enter (&startup_plug_type_id__volatile)) {
		GType startup_plug_type_id;
		startup_plug_type_id = startup_plug_get_type_once ();
		g_once_init_leave (&startup_plug_type_id__volatile, startup_plug_type_id);
	}
	return startup_plug_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

