/* Utils.c generated by valac 0.52.4, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
* Copyright 2013-2018 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "applications.h"
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define STARTUP_UTILS_AUTOSTART_DIR "autostart"
#define STARTUP_UTILS_FALLBACK_ICON "application-default-icon"

gchar*
startup_utils_get_user_startup_dir (void)
{
	gchar* config_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* startup_dir = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_strdup (_tmp0_);
	config_dir = _tmp1_;
	_tmp2_ = config_dir;
	_tmp3_ = g_build_filename (_tmp2_, STARTUP_UTILS_AUTOSTART_DIR, NULL);
	startup_dir = _tmp3_;
	_tmp4_ = startup_dir;
	if (g_file_test (_tmp4_, G_FILE_TEST_EXISTS) == FALSE) {
		GFile* file = NULL;
		const gchar* _tmp5_;
		GFile* _tmp6_;
		_tmp5_ = startup_dir;
		_tmp6_ = g_file_new_for_path (_tmp5_);
		file = _tmp6_;
		{
			GFile* _tmp7_;
			_tmp7_ = file;
			g_file_make_directory_with_parents (_tmp7_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp8_ = e;
			_tmp9_ = _tmp8_->message;
			g_warning ("Utils.vala:35: %s", _tmp9_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			_g_free0 (startup_dir);
			_g_free0 (config_dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_g_object_unref0 (file);
	}
	result = startup_dir;
	_g_free0 (config_dir);
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

gboolean
startup_utils_is_desktop_file (const gchar* name)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (name != NULL, FALSE);
	if (!string_contains (name, "~")) {
		_tmp0_ = g_str_has_suffix (name, ".desktop");
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GtkImage*
startup_utils_create_icon (StartupEntityAppInfo* app_info,
                           GtkIconSize icon_size)
{
	GThemedIcon* icon = NULL;
	StartupEntityAppInfo _tmp0_;
	const gchar* _tmp1_;
	GThemedIcon* _tmp2_;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp3_;
	GtkIconTheme* _tmp4_;
	gint pixel_size = 0;
	GtkImage* image = NULL;
	GtkImage* _tmp5_;
	GtkIconTheme* _tmp6_;
	GThemedIcon* _tmp7_;
	GtkIconInfo* _tmp8_;
	GtkIconInfo* _tmp9_;
	gboolean _tmp10_;
	GtkImage* _tmp25_;
	GError* _inner_error0_ = NULL;
	GtkImage* result = NULL;
	g_return_val_if_fail (app_info != NULL, NULL);
	_tmp0_ = *app_info;
	_tmp1_ = _tmp0_.icon;
	_tmp2_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks (_tmp1_);
	icon = _tmp2_;
	_tmp3_ = gtk_icon_theme_get_default ();
	_tmp4_ = _g_object_ref0 (_tmp3_);
	icon_theme = _tmp4_;
	switch (icon_size) {
		case GTK_ICON_SIZE_DIALOG:
		{
			pixel_size = 48;
			break;
		}
		case GTK_ICON_SIZE_DND:
		{
			pixel_size = 32;
			break;
		}
		default:
		{
			pixel_size = 32;
			break;
		}
	}
	_tmp5_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp5_);
	image = _tmp5_;
	_tmp6_ = icon_theme;
	_tmp7_ = icon;
	_tmp8_ = gtk_icon_theme_lookup_by_gicon (_tmp6_, (GIcon*) _tmp7_, pixel_size, GTK_ICON_LOOKUP_USE_BUILTIN);
	_tmp9_ = _tmp8_;
	_tmp10_ = _tmp9_ == NULL;
	_g_object_unref0 (_tmp9_);
	if (_tmp10_) {
		{
			GdkPixbuf* _tmp11_ = NULL;
			StartupEntityAppInfo _tmp12_;
			const gchar* _tmp13_;
			GdkPixbuf* _tmp14_;
			GdkPixbuf* pixbuf = NULL;
			GdkPixbuf* _tmp15_;
			GdkPixbuf* _tmp16_;
			GtkImage* _tmp17_;
			_tmp12_ = *app_info;
			_tmp13_ = _tmp12_.icon;
			_tmp14_ = gdk_pixbuf_new_from_file (_tmp13_, &_inner_error0_);
			_tmp11_ = _tmp14_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp15_ = gdk_pixbuf_scale_simple (_tmp11_, pixel_size, pixel_size, GDK_INTERP_BILINEAR);
			pixbuf = _tmp15_;
			_tmp16_ = pixbuf;
			_tmp17_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp16_);
			g_object_ref_sink (_tmp17_);
			_g_object_unref0 (image);
			image = _tmp17_;
			_g_object_unref0 (pixbuf);
			_g_object_unref0 (_tmp11_);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GThemedIcon* _tmp18_;
			GThemedIcon* _tmp19_;
			GtkImage* _tmp20_;
			GError* _tmp21_;
			const gchar* _tmp22_;
			err = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp18_ = (GThemedIcon*) g_themed_icon_new (STARTUP_UTILS_FALLBACK_ICON);
			_g_object_unref0 (icon);
			icon = _tmp18_;
			_tmp19_ = icon;
			_tmp20_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp19_, (GtkIconSize) icon_size);
			g_object_ref_sink (_tmp20_);
			_g_object_unref0 (image);
			image = _tmp20_;
			_tmp21_ = err;
			_tmp22_ = _tmp21_->message;
			g_debug ("Utils.vala:76: %s", _tmp22_);
			_g_error_free0 (err);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (image);
			_g_object_unref0 (icon_theme);
			_g_object_unref0 (icon);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	} else {
		GThemedIcon* _tmp23_;
		GtkImage* _tmp24_;
		_tmp23_ = icon;
		_tmp24_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp23_, (GtkIconSize) icon_size);
		g_object_ref_sink (_tmp24_);
		_g_object_unref0 (image);
		image = _tmp24_;
	}
	_tmp25_ = image;
	gtk_image_set_pixel_size (_tmp25_, pixel_size);
	result = image;
	_g_object_unref0 (icon_theme);
	_g_object_unref0 (icon);
	return result;
}

